precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform vec4 params;

vec2 center = vec2(0.5);
void main() {
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    color.rgb-=params.r*0.3;
    gl_FragColor = color;
}



