precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
vec4 backcolor=vec4(0.0,0.0,0.0,1.0);

float poss[9];
void main() {

    //矩形的个数
    float num = 9.0;
    float pre = 1.0 / num;
    poss[0] = 6.0;
    poss[1] = 1.0;
    poss[2] = 4.0;
    poss[3] = 0.0;
    poss[4] = 7.0;
    poss[5] = 3.0;
    poss[6] = 8.0;
    poss[7] = 2.0;
    poss[8] = 5.0;

    float infopos = 0.0;

    for (int i = 0; i < 9; i++) {
        if (textureCoordinate.y >= poss[i] * pre && textureCoordinate.y <= poss[i] * pre + pre) {
            break;
        }
        infopos++;
    }
    float startpro=infopos*pre;
    float endpro=startpro+pre;

    //    相对进度
    float usepro = 0.0;
    usepro=smoothstep(startpro,endpro,progress);
    float mixvalue=1.0;
    if (usepro < 0.25) {
        mixvalue = 0.0;
    } else if (usepro < 0.5) {
        mixvalue = 0.33;
    } else if (usepro < 0.75) {
        mixvalue = 0.66;
    }

    vec4 texColor1 = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = mix(
        backcolor,
        texColor1,
        mixvalue);
}

