precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;

float getpro(float x){
    if(x<0.05)return x;
    x=(x-0.05)/0.95;
    return sqrt(1.0 - pow(x - 1.0, 2.0));
}

void main() {
    vec4 color=texture2D(inputImageTexture, textureCoordinate);
    float usepro=1.0-getpro(progress);
    gl_FragColor=color*usepro;
    gl_FragColor.a=1.0;
//    gl_FragColor=color*usepro;
}
