precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec2 center = vec2(0.5);

vec2 changepos(vec2 uv) {
    float cha = abs(uv.y - 0.5);
    if (cha > 0.4) {
        float cha = cha - 0.4;
        float beishu = 1.0 - cha * 2.0;
        cha = cha * beishu;
        cha += 0.4;
        uv.y = 0.5 + (uv.y < 0.5 ? -1.0 : 1.0) * cha;
    }
    return uv;
}
void main() {
    vec2 uv = changepos(textureCoordinate);
    vec2 uvr = uv;
    vec2 uvg = (uv - center) / 1.01 + center;
    vec2 uvb = (uv - center) / 1.02 + center;
    float r = getFromColor(uvr).r;
    float g = getFromColor(uvg).g;
    float b = getFromColor(uvb).b;
    gl_FragColor = vec4(r, g, b, 1.0);
}
