precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

//水平镜像 镜像中间部分
void main() {
    float x = min(1.0 - textureCoordinate.x, textureCoordinate.x);

    vec2 uv = vec2(x + 0.25, textureCoordinate.y);

    gl_FragColor = getFromColor(uv);
}
