precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//垂直镜像 镜像中间部分
void main() {
    float y = min(1.0 - textureCoordinate.y, textureCoordinate.y);
    y +=0.25;
//    y = 0.75 - y;

    vec2 uv = vec2(textureCoordinate.x, y);
    gl_FragColor = getFromColor(uv);
}
