precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=1000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

vec2 center=vec2(0.5);

void main() {
    nowtime=mod(progress,druction)/druction;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if(nowtime>0.5){
        gl_FragColor=getFromColor(texCoord);
        return;
    }
    float usepro=getspeedpro(nowtime*2.0);
    float scale=usepro/20.0;
    texCoord=center+(texCoord-center)*(1.0-scale);

    vec4 color1=getFromColor(texCoord);
    texCoord.y+=(scale/2.0);
    texCoord.x-=(scale/2.0);
    vec4 color2=getFromColor(texCoord);
    texCoord.y-=scale;
    texCoord.x+=scale;
    vec4 color3=getFromColor(texCoord);
    color1.r=color2.r;
    color1.g=color3.g;
    gl_FragColor=color1;

}
