precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=2000.0;
highp float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))*nowtime) * 43758.5453);
}

//    只是一段用来分块的代码
//    fract 返回小数部分
vec2 fenkuai(vec2 pro, float sp){
    float usex=pro.x;
    float usey=pro.y;
    if(ratio>=1.0){
        usex=usex*sp*ratio-fract(usex*sp*ratio);
        usey=usey*sp-fract(usey*sp);
    }else{
        usex=usex*sp-fract(usex*sp);
        usey=usey*sp*ratio-fract(usey*sp*ratio);
    }
    return vec2(usex,usey)/sp;
}



void main() {
    nowtime=mod(progress,druction)/druction+0.1;
    nowtime*=100.0;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec4 color=getFromColor(texCoord);
    float sp=1080.0;
    texCoord=fenkuai(texCoord,sp);
    float num=Rand(texCoord)/2.0;
    gl_FragColor.rgb=mix(color.rgb,vec3(num),0.2);
    gl_FragColor.a=1.0;
//    gl_FragColor=vec4(vec3(num),1.0);

}
