precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=2000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

//    只是一段用来分块的代码
//    fract 返回小数部分
vec2 fenkuai(vec2 pro, float sp){
    float usex=pro.x;
    float usey=pro.y;
    if(ratio>=1.0){
        usex=usex*sp*ratio-fract(usex*sp*ratio);
        usey=usey*sp-fract(usey*sp);
    }else{
        usex=usex*sp-fract(usex*sp);
        usey=usey*sp*ratio-fract(usey*sp*ratio);
    }
    return vec2(usex,usey)/sp;
}



void main() {
    nowtime=mod(progress,druction)/druction*0.1;
//    nowtime*=100.0;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec4 color=getFromColor(texCoord);

    texCoord=fenkuai(texCoord,720.0);

    float mixnum=0.2;
    float maxmix=5.0;//前面数字越小越细
    float smod=mod((texCoord.y+nowtime)*480.0/ratio,maxmix);
    smod=0.5+abs(smod-maxmix/2.0)/maxmix;
    vec4 color2=vec4(smod,smod,smod,1.0);
    gl_FragColor=mix(color,color2,mixnum);

}
