precision highp float;
varying highp vec2 textureCoordinate;
uniform vec4 color;
uniform int type;
uniform float alpha;
uniform sampler2D inputImageTexture;

vec4 empty = vec4(0.0);

void main() {
    if (type < 0) {
        float mixvalue;
        float tocenter = length(vec2(0.5) - textureCoordinate);
        mixvalue = 1.0-max(0.0, 1.0 - tocenter * 2.0);

//        if (type == -1) {
//            float tocenter = length(vec2(0.5) - textureCoordinate);
//            mixvalue = 1.0-max(0.0, 1.0 - tocenter * 2.0);
//        } else {
//            float usey = textureCoordinate.y < 0.5 ? 0.5 - textureCoordinate.y : textureCoordinate.y - 0.5;
//            mixvalue = usey * 2.0;
//        }
        gl_FragColor = mix(color, empty, mixvalue);
    } else {
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    }
    gl_FragColor *= alpha;
}
