precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
//0-3
//上下擦入 下上擦入 左右擦入 右左擦入
uniform lowp int type;
uniform lowp float ratio;

const float PI = 3.1415926;
void main() {
    vec2 pos =textureCoordinate;
    bool draw=true;
    if(type==0){
        draw=pos.x<=progress;
    }else if(type==1){
        draw=pos.x>=1.0-progress;
    }else if(type==2){
        draw=pos.y<=progress;
    }else if(type==3){
        draw=pos.y>=1.0-progress;
    }else if(type==4){
        vec2 center=vec2(0.5);
        if(ratio>1.0){
            pos.y/=ratio;
            center.y/=ratio;
        }else{
            pos.x*=ratio;
            center.x*=ratio;
        }
        draw=length(pos-center)<progress*0.75;
        pos=textureCoordinate;
    }else if(type==5){
        pos.y=pos.y-1.0+progress*2.0;
    }
    if(draw){
        gl_FragColor = texture2D(inputImageTexture, pos);
    }else{
        gl_FragColor=vec4(0.0);
    }
}


