precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
// x偏移幅度，越大偏移越大
uniform float lengthsize;
float druction=2000.0;
float nowtime=0.0;


vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}


//    只是一段用来分块的代码
float fenkuai(float pro){
    float sp=50.0;
    float usey=pro*sp-fract(pro*sp);
    return usey;
}


/*
当progress<0.05的时候不进行偏移
其他时间生成三个控制偏移的随机数，
每个偏移又对应一个颜色偏移的随机数，
一个左右偏移的随机数

*/

vec4 getmovecolor(float movecolor, float movepos, float length, vec2 pos, float showpos){
    length*=lengthsize;
    if (movepos>0.5){
        length=-length;
    }
    vec4 rtn=getFromColor(pos);
    vec2 change=vec2(pos.x+0.01+length, pos.y);
    vec4 color=getFromColor(change);
//    color.a=1.0;
//    rtn.a=1.0;
    if (abs(showpos-0.5)<0.25){
        if (movecolor<0.33){
            rtn.r= color.r;
        } else if (movecolor>0.66){
            rtn.g= color.g;
        } else {
            rtn.b= color.b;
        }
        rtn.a=max(rtn.a,color.a);
        return rtn;
    } else {
        if (movecolor<0.33){
            color.r= rtn.r;
        } else if (movecolor>0.66){
            color.g= rtn.g;
        } else {
            color.b= rtn.b;
        }
        color.a=max(rtn.a,color.a);
        return color;
    }

}



void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    if(progress==1.0){
        gl_FragColor=getFromColor(texCoord);
        return;
    }
    nowtime=mod(progress*2000.0,druction)/druction;
    if (nowtime<0.05){
        gl_FragColor=getFromColor(texCoord);
        return;
    }
    float usepro=fenkuai(nowtime);

    float mstart1=Rand(vec2(usepro))*0.8;
    float mstart2=Rand(vec2(usepro+1.5))*0.8;
    float mstart3=Rand(vec2(usepro+2.0))*0.8;
    float mstart4=Rand(vec2(usepro+2.5))*0.8;

    float mlength1=Rand(vec2(usepro+2.5));
    float mlength2=Rand(vec2(usepro+2.5));
    float mlength3=Rand(vec2(usepro+2.5));
    float mlength4=Rand(vec2(usepro+2.5));

    float movecolor1=Rand(vec2(usepro+1.1));
    float movecolor2=Rand(vec2(usepro+1.2));
    float movecolor3=Rand(vec2(usepro+1.3));
    float movecolor4=Rand(vec2(usepro+1.4));

    float movepos1=Rand(vec2(usepro+2.1));
    float movepos2=Rand(vec2(usepro+2.2));
    float movepos3=Rand(vec2(usepro+2.3));
    float movepos4=Rand(vec2(usepro+2.4));

    float showpos1=Rand(vec2(usepro+2.21));
    float showpos2=Rand(vec2(usepro+2.22));
    float showpos3=Rand(vec2(usepro+2.23));
    float showpos4=Rand(vec2(usepro+2.24));

    if (texCoord.y>mstart1&&texCoord.y<mstart1+mlength1){
        gl_FragColor=getmovecolor(movecolor1, movepos1, mlength1, texCoord, showpos1);
        return;
    }
    if (texCoord.y>mstart2&&texCoord.y<mstart2+mlength2){
        gl_FragColor=getmovecolor(movecolor2, movepos2, mlength2, texCoord, showpos2);
        return;
    }
    if (texCoord.y>mstart3&&texCoord.y<mstart3+mlength3){
        gl_FragColor=getmovecolor(movecolor3, movepos3, mlength3, texCoord, showpos3);
        return;
    }
    if (texCoord.y>mstart4&&texCoord.y<mstart4+mlength4){
        gl_FragColor=getmovecolor(movecolor4, movepos4, mlength4, texCoord, showpos4);
        return;
    }

    gl_FragColor=getFromColor(texCoord);
}
