//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float type;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float poss[7];
//y=x*1.4-0.2
void main() {

    poss[0]=1.0;
    poss[1]=6.0;
    poss[2]=3.0;
    poss[3]=0.0;
    poss[4]=4.0;
    poss[5]=5.0;
    poss[6]=2.0;


    //矩形的个数
    float num = 7.0;
    float pre = 1.0 / num;
    float infopos;
    float usey=type==1.0?textureCoordinate.y:(1.0 - textureCoordinate.y);
    float usevalue = usey - textureCoordinate.x * 1.4 + 0.2;
    usevalue/=3.0;
//    记录下符号
    float fuhao=1.0;
    if(usevalue!=0.0){
        fuhao=usevalue/abs(usevalue);
    }

    usevalue = abs(usevalue);
    usevalue -= pre / 2.0;

    if (usevalue < 0.0) {
        infopos = 0.0;
    } else {
        infopos = usevalue * num;
        infopos = infopos - mod(infopos, 1.0);
        infopos += 1.0;
    }
    infopos=infopos*fuhao+3.0;
    float pos=0.0;
    for (int i = 0; i < 7; i++) {
        if(abs(poss[i]-infopos)<0.1){
            break;
        }
        pos++;
    }

    float startpro=pos*pre;
    float endpro=startpro+pre;
    float usepro = smoothstep(startpro, endpro, progress);
    float mixvalue = 1.0;
    if (usepro < 0.25) {
        mixvalue = 0.0;
    } else if (usepro < 0.5) {
        mixvalue = 0.33;
    } else if (usepro < 0.75) {
        mixvalue = 0.66;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor2, texColor1, 1.0 - mixvalue);
}
