//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
//x分割几部分，y横向分割还是纵向分割,>0 横向切，<0纵向
uniform lowp vec2 splitinfo;
//方向，>0就是0-1，<0就是1-0；
uniform lowp vec3 direction;


vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}



void main() {
    float mixvalue;
    float usepro = progress;

    float usevalue;
    float comparevalue;
    if(splitinfo.y>0.0){
        usevalue=textureCoordinate.y;
        comparevalue=textureCoordinate.x;
    }else{
        usevalue=textureCoordinate.x;
        comparevalue=textureCoordinate.y;
    }
    usevalue*=splitinfo.x;
    bool usedirection;
    if(usevalue<1.0){
        usedirection=direction.x>0.0;
    }else if(usevalue<2.0){
        usedirection=direction.y>0.0;
    }else {
        usedirection=direction.z>0.0;
    }


    if (!usedirection) {
        mixvalue = comparevalue > usepro ? 0.0 : 1.0;
    } else {
        mixvalue = (1.0 - comparevalue) > usepro ? 0.0 : 1.0;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor1, texColor2, mixvalue);
}
