//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

float center=0.2;



vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


void main() {
    float mixvalue;
    float usepro = progress;

    if(textureCoordinate.y<=center){
        mixvalue=textureCoordinate.y<center*usepro?0.0:1.0;
    }else{
        mixvalue=textureCoordinate.y>1.0-(1.0-center)*usepro?0.0:1.0;
    }

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor1, texColor2, 1.0-mixvalue);
}
