//矩形转场 左下到右上
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp int type;


vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//y=-x*1.7 -->y=-x*1.7+2.71
void main() {
    float mixvalue;
    float usepro=progress*2.71;
    vec2 usepos;
    if(type==0){
        usepos=textureCoordinate;
    } else if(type==1){
        usepos=textureCoordinate;
        usepos.x=1.0-usepos.x;
    }  else if(type==2){
        usepos=textureCoordinate;
        usepos.y=1.0-usepos.y;
    } else if(type==3){
        usepos=vec2(1.0)-textureCoordinate;
    }
    mixvalue=usepos.y<usepos.x*-1.7+usepro?1.0:0.0;

    vec4 texColor1 = getFromColor(textureCoordinate);
    vec4 texColor2 = getToColor(textureCoordinate);
    gl_FragColor = mix(texColor1, texColor2, mixvalue);
}
