precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

//默认横纵比
uniform lowp float ratio;

// y坐标每100/splitnum算作一个部分，y轴作为短边时候20个，若是长边则/ratio增加相应数量
float splitnum=4.0;
//0.0顺序排列 1.0 交叉
 lowp float hengshu=0.0;
 lowp float jiaocha=0.0;
//=0 两侧从上到下重合 1 从下到上重合
 lowp float shunxu=1.0;
float xishu=0.4;


vec2 getstartmove(float texCoord){
    float usenum=texCoord*100.0;
    if(shunxu==1.0){
        usenum= 100.0-usenum;
    }
    //    转成0-19个整数
    int num1=int(usenum/splitnum);
    float danshuang=mod(float(num1),2.0);
//    if(danshuang==1.0&&jiaocha==1.0)num1-=1;
    float num=float(num1)*splitnum/100.0;
    if(jiaocha>0.2&&danshuang==1.0){
        num=1.0-num;
    }
    //    负的偏移量 0-0.4
    float my=-(1.0-num*num)*xishu;
    if(jiaocha==1.0)
        my=-((cos((num + 1.) * PI) / 2.0) + 0.5)*xishu;
    vec2 startmove=vec2(danshuang, my);
    return startmove;
    }
float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
    useprogress = (cos((useprogress + 1.0) * PI) / 2.0) + 0.5;
    return useprogress;
}
void main() {
    //    splitnum/=ratio;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
//    用哪个值来进行计算startmove
    float choosenum=texCoord.x;
//    用哪个值判断
    float boolnum=texCoord.y;
    if(hengshu==1.0){
        choosenum=texCoord.y;
        boolnum=texCoord.x;
    }
    vec2 startmove=getstartmove(choosenum);
    bool isinbool=false;

    float useprogress =getuseprogress(2.0);
    if (startmove.x==0.0){
        isinbool=boolnum<(useprogress*1.6+startmove.y);
    } else {
        isinbool=boolnum>1.0-(useprogress*1.6+startmove.y);
    }

    float isin=(isinbool)?1.0:0.0;
    vec2 center=vec2(0.5);
    vec2 usefrom=center+(texCoord-center)*(1.0-progress*0.2);
    vec2 useto=center+(texCoord-center)*(1.0-(1.0-progress)*0.2);
    gl_FragColor= mix(
    getFromColor(usefrom),
    getToColor(useto),
    isin);
}
