precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
vec4 balck = vec4(0.0, 0.0, 0.0, 1.0);

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    vec4 usecolor;
    bool showbalck;
    if (progress < 0.5) {
        usecolor = getFromColor(uv);
        showbalck=abs(uv.x-0.5)>0.5-progress;
    } else {
        usecolor = getToColor(uv);
        showbalck=abs(uv.x-0.5)>0.5-(1.0-progress);
    }
    gl_FragColor = showbalck?balck:usecolor;
}
