precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
float move;
float cha=0.01;
const float PI = 3.1415926;
vec2 center=vec2(0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}


vec2 reset(vec2 texCoord){

    if (texCoord.x>-1.0&&texCoord.x<0.0){
        texCoord.x=-texCoord.x;
    }
    if(texCoord.x<-1.0){
        texCoord.x=texCoord.x+2.0;
    }
    if (texCoord.x>1.0&&texCoord.x<2.0){
        texCoord.x=2.0-texCoord.x;
    }
    if(texCoord.x>2.0){
        texCoord.x=texCoord.x-2.0;
    }
    if (texCoord.y>-1.0&&texCoord.y<0.0){
        texCoord.y=-texCoord.y;
    }
    if(texCoord.y<-1.0){
        texCoord.y=texCoord.y+2.0;
    }
    if (texCoord.y>1.0&&texCoord.y<2.0){
        texCoord.y=2.0-texCoord.y;
    }
    if(texCoord.y>2.0){
        texCoord.y=texCoord.y-2.0;
    }
    return texCoord;
}

vec2 reset2(vec2 texCoord){
    if(texCoord.x<0.0){
        texCoord.x=0.0;
    }else if(texCoord.x>1.0){
        texCoord.x=1.0;
    }
    if(texCoord.y<0.0){
        texCoord.y=0.0;
    }else if(texCoord.y>1.0){
        texCoord.y=1.0;
    }
    return texCoord;

}


float as [8] ;
float getvalue(float time) {
    float druction=100.0;

    if (time <= 0.0) return as[0];
    if (time>=druction){
        return as[7];
    }
    float length=8.0;
    //        每段变化的持续时间
    float averagetime = float (druction/(length - 1.0));
    //        转化为持续时间内的时间
    float inputpos = (mod(time, druction) / druction) * druction;
    //        位于第几个间隔
    int pos = 0;
    float pos2=0.0;
    for(;pos<8;pos++){
        pos2+=1.0;
        if(averagetime*pos2>inputpos)break;
    }

    float  start = as[pos];
    float  end = as[pos + 1];

    //        KLog.e(input);
    float pro=mod(inputpos, averagetime) / averagetime;
    pro=getspeedpro(pro);
    float nowvalue = start + (end - start) * (pro);
    return nowvalue;
}

//左右抖动
void main() {
    as[0]=-0.16;
    as[1]=0.08;
    as[2]=-0.04;
    as[3]=0.02;
    as[4]=-0.01;
    as[5]=0.005;
    as[6]=-0.001;
    as[7]=0.0;
    float pp=2.0+progress*98.0;
    move=getvalue(pp);
    float oldmove=getvalue(pp-0.0098);
    cha =oldmove-move;
    cha*=20.0;
    move*=-2.3;
    vec2 texCoord=textureCoordinate/vec2(1.0);
    center.y-=move/2.0;
    texCoord.y-=move;

    float scale=1.0-sqrt(progress);
    scale=getspeedpro(scale);
    vec2 usecha=center-texCoord;
    usecha=usecha*(1.0-(scale)/2.0);
    texCoord=center-usecha;

    texCoord=reset(texCoord);
    //    gl_FragColor=texture2D(inputImageTexture,texCoord);

    float num=5.0;
    vec4 color=vec4(0.0);
    float total=0.0;
    for (float t = 0.0; t <= num*2.0; t++) {
        float weight=1.0;
        vec2 movepos=texCoord;
        movepos.y=texCoord.y-(num-t)*cha;
        movepos=reset2(movepos);
        vec4 use=texture2D(inputImageTexture, movepos);
        color += use;
        total += use.a;
    }

    gl_FragColor= vec4(color / total);

}
