precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;

float getusepeo(){
    return sqrt(progress);
}
vec2 center=vec2(0.5);

float type=0.0;
void main() {
    vec2 texCoord=textureCoordinate-center;
//    texCoord*=(0.8+getusepeo()/5.0);

    if(type==0.0){
        texCoord.x/=getusepeo();
    }else {
        texCoord.y/=getusepeo();
    }

    if(abs(texCoord.x)>0.5||abs(texCoord.y)>0.5)
    gl_FragColor=vec4(0.0);
    else
    gl_FragColor=texture2D(inputImageTexture, center+texCoord);
}
