precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

vec2 center = vec2(0.5);
void main() {
    vec2 uv = textureCoordinate.xy / 1.0 - center;
    //    缩放
    uv /= progress;
    uv += center;
    vec4 color = texture2D(inputImageTexture, uv);
    gl_FragColor = color;
}



