precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

uniform vec2 center;
uniform vec2 move;
uniform float scale;




void main() {
    vec2 pos = textureCoordinate / 1.0;
    pos=(pos-center)/scale+center+move;
    gl_FragColor = texture2D(inputImageTexture, pos);

}
