precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform int type;

uniform vec3 domove;
uniform vec3 domove2;

vec2 center=vec2(0.5);

vec4 getToColor(vec2 uv) {
    float scale=0.9+progress*0.1;
    uv=center+(uv-center)*scale;
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

vec4 showcolor=vec4(1.0,0.5,0.47,1.0);
float showwidth;

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    vec2 check;
    if(type==1){
        check=uv;
    }else if(type==2){
        check=uv.yx;
    }

    float uspro;
    float showwidth;
    float offcenter;
    float tocenter;
    if(check.y<1.0/3.0){
        uspro=domove[0];
        showwidth=domove2[0];
        offcenter=0.4;
    }else if(check.y<2.0/3.0){
        uspro=domove[2];
        showwidth=domove2[2];
        offcenter=0.5;
    }else{
        uspro=domove[1];
        showwidth=domove2[1];
        offcenter=0.55;
    }
    if(uspro<=0.0){
        gl_FragColor=getFromColor(uv);
        return;
    }else if(uspro>=1.0){
        gl_FragColor=getToColor(uv);
        return;
    }

    tocenter=check.x<offcenter?offcenter:1.0-offcenter;
    uspro*=tocenter;
//    showwidth*=tocenter;

    if(abs(check.x-offcenter)>uspro){
        gl_FragColor=getFromColor(uv);
        return;
    }

    if(uspro-abs(check.x-offcenter)<showwidth){
        gl_FragColor = showcolor;
        return;
    }

    gl_FragColor=getToColor(uv);
}
