// 5-9 圆环
// https://gl-transitions.com/editor/heart
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

//圆形
float sdCircle(vec2 p, float r)
{
    return length(p) - r;// 到圆表面的距离
}

float isincircle(vec2 pos, vec2 usecenter, float length) {
    vec2 st = pos - usecenter;
    if (ratio > 1.) {
        st.y = st.y / ratio;
    } else {
        st.x = st.x * ratio;
    }
    float l = sdCircle(st, length);
    return l;
}
float circlenum = 6.0;
//最中心的初始宽度
float startsize = 0.1;

vec2 center = vec2(0.5);
float PI = 3.14159;
void main() {
    //    center.x = sin(progress * PI);
    //    center.y = cos((progress + 0.5) * PI) + 1.0;
    startsize=pow(progress,2.0)*0.1;
    float size = 1.0 + abs(sin((progress) * 10.0 * PI)) *progress * 10.0;
    //        size=max(1.0,size);
    startsize = startsize * size;
    float offsize = startsize / 2.0;
    for (float i = 0.0; i < circlenum; i++) {
        float usesize = startsize + i * offsize;
        float l = isincircle(textureCoordinate, center, usesize);
        if (l < 0.0) {
            gl_FragColor = mod(i, 2.0) == 0.0 ?
            getToColor(textureCoordinate) : getFromColor(textureCoordinate);
            return;
        }
    }
    gl_FragColor = getFromColor(textureCoordinate);
}
