precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float tranx;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

void main() {
    vec2 pos=textureCoordinate/1.0;
    pos.x+=tranx;
    if(pos.x<0.0){
        gl_FragColor=getFromColor(textureCoordinate);
    }else{
        pos.x=mod(pos.x,1.0);
        gl_FragColor = getToColor(pos);
    }

}
