/// 碧绿效果.fsh

precision mediump float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
uniform lowp float Time;


void main() {
    vec3 col = texture2D(inputImageTexture, textureCoordinate).rgb;
    gl_FragColor.r = pow(col.g-col.b,2.0)/0.5;
    gl_FragColor.g = pow(col.r-col.g,2.0)/0.5;
    gl_FragColor.b = pow(col.r-col.g,2.0)/0.5;
    gl_FragColor.a = 1.0;
}