precision mediump float;
uniform sampler2D u_TextureUnit;
varying vec2 v_TextureCoordinates;

uniform float u_Offset;
uniform float type;//显示范围 rgb 1red 2g 3b

float changeval(float val){
    if(val>1.0){
    val=1.0;
    }
    if(val<0.0){
    val=0.0;
    }
    return val;
}
void main()
{
    vec4 origin = texture2D(u_TextureUnit, v_TextureCoordinates);

    float minx=changeval(v_TextureCoordinates.x+ u_Offset);
    float miny=changeval(v_TextureCoordinates.y+ u_Offset);

    vec4 red = texture2D(u_TextureUnit, vec2(minx,v_TextureCoordinates.y));
    if(type==0.0){
     float maxx=changeval(v_TextureCoordinates.x- u_Offset);
     float maxy=changeval(v_TextureCoordinates.y- u_Offset);
     vec4 green = texture2D(u_TextureUnit, vec2(maxx,v_TextureCoordinates.y));

    gl_FragColor = vec4(red.x, origin.y,green.z, origin.w);//rgb
    }
    else if(type==1.0){
    gl_FragColor = vec4(red.x, origin.y,origin.z, origin.w);//gb
   }
   else if(type==2.0){
   gl_FragColor = vec4(origin.x, red.y,origin.z, origin.w);//rb
   }
   else{
    gl_FragColor = vec4(origin.x, origin.y,red.z, origin.w);//rg
   }




}