precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;
uniform vec4 params;
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
void main() {
    vec2 uv = textureCoordinate;
    vec4 oldcolor = texture2D(inputImageTexture, uv);
    vec4 color = oldcolor;
    float pro = fract(progress / 2000.0);
    if (pro < 0.5) {
        pro = pro * 10.0;
        if (fract(pro) < 0.5) {
            color.rgb = vec3(1.0) - color.rgb;
        }
    }
    gl_FragColor = mix(oldcolor, color, params.r);
}
