precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
float PI=3.14159;

float getusepro(float x) {
    return x < 0.5
    ? (1.0 - sqrt(1.0 - pow(2.0 * x, 2.0))) / 2.0
    : (sqrt(1.0 - pow(-2.0 * x + 2.0, 2.0)) + 1.0) / 2.0;
}

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
void main() {
    vec2 uv = textureCoordinate;
    float usepro = progress;
    bool iscenter=abs(uv.y-0.5)<1.0/6.0;
    if(usepro<=0.5){
        usepro=getusepro(usepro*2.0)/2.0;
        if(iscenter&&abs(uv.x-0.5)<usepro){
            gl_FragColor = getFromColor(uv);
        }else{
            gl_FragColor = black;
        }
        return;
    }
    if(iscenter){
        gl_FragColor = getFromColor(uv);
        return;
    }
    usepro-=0.5;
    usepro=getusepro(usepro*2.0)/2.0;
    if(abs(uv.y-0.5)<usepro){
        gl_FragColor = getFromColor(uv);
    }else{
        gl_FragColor = black;
    }
}
