precision mediump float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

void main() {
   vec2 usepos;
//    确定是哪一部分
    float comparevalue;
//    这个计算偏移数值
    float usevalue;
    float useprogress=1.0-progress;
    comparevalue=1.0-textureCoordinate.x;
    usevalue=textureCoordinate.y;
    if(comparevalue*2.0>1.0){
        usevalue-=useprogress;
    }else{
        usevalue+=useprogress;
    }
    if(abs(0.5-usevalue)>0.5){
        gl_FragColor= vec4(1.0);
    }else{
        usepos=vec2(1.0-comparevalue,usevalue);
        gl_FragColor= getFromColor(usepos);
    }
}
