precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}


float getusepro(float x) {
    return x < 0.5
    ? (1.0 - sqrt(1.0 - pow(2.0 * x, 2.0))) / 2.0
    : (sqrt(1.0 - pow(-2.0 * x + 2.0, 2.0)) + 1.0) / 2.0;
}

vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
void main() {
    vec2 uv = textureCoordinate - vec2(0.5);
    float usepro = progress;
    usepro = getusepro(usepro) / 2.0;

    bool isblack = abs(uv.x) < usepro || abs(uv.y) < usepro;
    gl_FragColor = isblack ? getFromColor(textureCoordinate) : black;
}
