precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float getusepro(float x) {
    return x < 0.5
    ? (1.0 - sqrt(1.0 - pow(2.0 * x, 2.0))) / 2.0
    : (sqrt(1.0 - pow(-2.0 * x + 2.0, 2.0)) + 1.0) / 2.0;
}


vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
// y=0.2*x+0.25;
// y=0.2*x-0.25;
void main() {
    vec2 off=vec2(-1.0,-0.2);
    vec2 uv=textureCoordinate-vec2(0.5);
    float value=uv.y-0.2*uv.x;
    bool iscenter=abs(value)<0.25;
    uv=textureCoordinate;
    if(iscenter){
        float usepro=progress<0.5?(0.5-progress)*2.0:0.0;
        usepro=getusepro(usepro);
        uv=uv-off*usepro;
    }else{
        float usepro=progress>0.5?(1.0-progress)*2.0:1.0;
        usepro=getusepro(usepro);
        if(uv.y<0.5){
            uv=uv-off*usepro;
        }else{
            uv=uv+off*usepro;
        }
    }
    if(abs(uv.x-0.5)>0.5||abs(uv.y-0.5)>0.5){
        gl_FragColor = black;
        return;
    }

    gl_FragColor = getFromColor(uv);
}
