 precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform float ratio;
const float PI = 3.1415926;
 float getusepro(float x) {
     return x < 0.5
     ? (1.0 - sqrt(1.0 - pow(2.0 * x, 2.0))) / 2.0
     : (sqrt(1.0 - pow(-2.0 * x + 2.0, 2.0)) + 1.0) / 2.0;
 }


 vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

vec4 black=vec4(0.0,0.0,0.0,1.0);
float startingAngle=270.0;
void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float offset = startingAngle * PI / 180.0;
    float angle = atan(uv.y - 0.5, uv.x - 0.5) + offset;
    float normalizedAngle = (angle + PI) / (2.0 * PI);

    normalizedAngle = normalizedAngle - floor(normalizedAngle);
    float usepro=progress<0.01?0.0:(progress-0.01)/0.99;
    usepro=getusepro(usepro);
    gl_FragColor= mix(
        black,
        getFromColor(uv),
        step(normalizedAngle, usepro)
    );

}
