precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

//垂直镜像
void main() {
    float y = max(1.0 - textureCoordinate.y, textureCoordinate.y);

    vec2 uv = vec2(textureCoordinate.x, y);

    gl_FragColor = getFromColor(uv);
}
