precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;


vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

float offamx = 0.01;

void main() {
    vec2 uv = textureCoordinate;
    float usepro = progress * 2.0;
    if (usepro > 1.0) {
        usepro = 2.0 - usepro;
    }
    usepro = uv.x < 0.5 ? usepro - 0.5 : 0.5 - usepro;
    float off = usepro * offamx;
    float cha = (uv.x - 0.5);
    uv.x = 0.5 + cha * (1.0 - off);
    gl_FragColor = getFromColor(uv);
}
