precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=2000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

vec2 getscale(vec2 pos ,vec2 center,float scale){
    vec2 cha=center-pos;
    cha*=scale;
    return center-cha;
}


//0.2 0.4 0.8 1.0 四个分段
float scale=1.0;
void main() {
    nowtime=mod(progress,druction)/druction;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    float scaleadd=(nowtime<0.5?nowtime:1.0-nowtime)/2.0;


    vec2 center=vec2(0.15, 0.5);
    vec2 center2=vec2(0.0);
    vec2 center3=vec2(0.0);
    vec4 color=vec4(0.0);

    vec2 pos1=vec2(0.0);
    vec2 pos2=vec2(0.0);
    vec2 pos3=vec2(0.0);

    float scale=1.0;
    float scale2=1.0;
    float scale3=1.0;

    vec2 toppos=vec2(0.5,0.15);
    toppos=getscale(toppos,center,1.0/(1.0-scaleadd*1.2));

    if (texCoord.y<toppos.y){
        center=vec2(0.6, toppos.y+0.2);
        center2=vec2(0.2,toppos.y+0.4);
        center3=vec2(0.6,toppos.y+0.2);
        scale=1.0-scaleadd;
        scale2=1.0-scaleadd;
//        scale3=1.0-scaleadd*1.5;
        scale3=scale;
    }
    else if (texCoord.y<0.4){
        center=vec2(0.15, 0.4);
        center2=vec2(0.15, 0.4);
        center3=vec2(0.85, 0.5+scaleadd);
        scale=1.0-scaleadd/2.0;
        scale2=scale;
        scale3=1.0-scaleadd;
    }
    else if (texCoord.y<1.0-toppos.y){
        center=vec2(0.15, 0.4);
        center2=vec2(0.5-scaleadd/3.0, 0.5);
        center3=vec2(0.15, 0.4);
        scale=1.0-scaleadd/2.0;
        scale2=1.0-scaleadd;
        scale3=scale;
//        scale3=1.0-scaleadd*1.2;
    }
    else {
        center=vec2(0.5, 1.0-toppos.y);
        center2=vec2(0.5, 0.8);
        center3=vec2(0.5, 0.8);
        scale=1.0-scaleadd;
        scale2=1.0-scaleadd*1.2;
        scale3=1.0-scaleadd*1.5;
    }
    pos1=getscale(texCoord,center,scale);
    color=getFromColor(pos1);

    pos2=getscale(texCoord,center2,scale2);
    vec4 color2=getFromColor(pos2);

    pos3=getscale(texCoord,center3,scale3);
    vec4 color3=getFromColor(pos3);

    color.r=color2.r;
    color.g=color3.g;
    gl_FragColor=color;
}
