precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=2000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}
float movexrb=0.01;
float value=0.0;
//生成10随机y轴坐标 改坐标与上一坐标之间的距离画一个圆
float centerys[21];
float usepro=5.0;

float movemax=0.0;

//    只是一段用来分块的代码,1/sp
float fenkuai(float pro,float sp){
    float usey=pro*sp-fract(pro*sp);
    return usey;
}

vec3 getmove(float zhongzi){
    float rand1=Rand(vec2(zhongzi));
    float pian1=Rand(vec2(rand1));
    float pian11=Rand(vec2(pian1));
    pian11=0.001+pian11/200.0;
    return vec3(rand1, pian1, pian11);
}



void main() {
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec4 color=getFromColor(texCoord);
    nowtime=mod(progress,druction)/druction;
    float usepos=fenkuai(nowtime,20.0);

    vec3 move1=getmove(usepos);
    vec3 move2=getmove(usepos+0.25);
    vec3 off1=getmove(usepos-0.15);
    vec3 off2=getmove(usepos+0.15);


    vec2 usetc=texCoord;

    if (texCoord.y>move1.x && texCoord.y<move1.x+move1.y){
        usetc.x+=move1.z;
        vec4 colorp1=getFromColor(usetc);
        color.r=colorp1.r;
    } else if (texCoord.y>move2.x && texCoord.y<move2.x+move2.y){
        usetc.x-=move2.z;
        vec4 colorp2=getFromColor(usetc);
        color.b=colorp2.b;
    }
    usetc=texCoord;
    if (texCoord.y>off1.x && texCoord.y<off1.x+off1.y){
        usetc.x+=off1.z;
        color=getFromColor(usetc);
    } else if (texCoord.y>move2.x && texCoord.y<move2.x+move2.y){
        usetc.x-=off2.z;
        color=getFromColor(usetc);
    }
    //    绿块
    float random=Rand(move1.xy);
    if (random>0.6){
        vec3 g1=getmove(usepos+0.35);

        if (texCoord.y>g1.x && texCoord.y<g1.x+g1.y/5.0){
            color.r=0.0;
            color.b=0.0;
            color.g*=2.0;
        }
    }


    random=Rand(move1.yz);
    if (random>0.5){
        vec3 g2=getmove(usepos-0.35);
        if (texCoord.y>g2.x && texCoord.y<g2.x+g2.y/5.0){
            float random2=Rand(vec2(random));
            if(random>0.8&&abs(texCoord.x-random2)>(g2.y/10.0)/ratio){
                gl_FragColor=color;
                return;
            }
            color.r=0.0;
            color.b=0.0;
            color.g*=2.0;
           /* random=Rand(vec2(random));
            float random2=Rand(vec2(random));
            if(random2>0.5&&abs(texCoord.x-random2)<(g2.y/10.0)/ratio){
                float colorpos=0.0;
                float imax=g2.y*100.0;
                for(float i=0.0;i<imax*2.0;i++){
                    if(texCoord.y>g2.x+0.005*i){
                        colorpos+=1.0;
                    }else{
                        break;
                    }
                }
                colorpos=mod(colorpos,3.0);
                color=vec4(0.0,0.0,0.0,1.0);
                if(colorpos<0.5){
                    color.r=1.0;
                }else if(colorpos<1.5){
                    color.g=1.0;
                }else{
                    color.b=1.0;
                }
            }*/
        }

    }

//    三色条纹快
    random=Rand(vec2(random));
    if(random>0.5){
        vec3 g2=getmove(usepos-0.45);
        g2.y=0.1+g2.y/10.0;
        if(texCoord.y>g2.x&&texCoord.y<g2.x+g2.y){
        float random2=Rand(vec2(random));
            if(random>0.8&&abs(texCoord.x-random2)>(g2.y/2.0)/ratio){
                gl_FragColor=color;
                return;
            }
            float colorpos=0.0;
            float imax=g2.y*100.0;
            for(float i=0.0;i<imax*2.0;i++){
                if(texCoord.y>g2.x+0.005*i){
                    colorpos+=1.0;
                }else{
                    break;
                }
            }
            colorpos=mod(colorpos,3.0);
            color=vec4(0.0,0.0,0.0,1.0);
            if(colorpos<0.5){
                color.r=1.0;
            }else if(colorpos<1.5){
                color.g=1.0;
            }else{
                color.b=1.0;
            }
        }
    }


    gl_FragColor=color;
}
