precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=750.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

vec2 center=vec2(0.5);

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

void main() {
    nowtime=mod(progress,druction)/druction;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec4 color1= getFromColor(texCoord);
    float usepro=getspeedpro(nowtime);
    vec2 t2=center+(texCoord-center)*(1.0-usepro/2.0);
    vec4 color2= getFromColor(t2);
    gl_FragColor=mix(color1,color2,(1.0-usepro)/2.0);

}
