precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=2000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))*nowtime) * 43758.5453);
}

vec2 fenkuai(vec2 pro, float sp){
    float usex=pro.x;
    float usey=pro.y;
    if(ratio>=1.0){
        usex=usex*sp*ratio-fract(usex*sp*ratio);
        usey=usey*sp-fract(usey*sp);
    }else{
        usex=usex*sp-fract(usex*sp);
        usey=usey*sp*ratio-fract(usey*sp*ratio);
    }
    return vec2(usex,usey)/sp;
}
vec3 startc=vec3(1.0);
vec3 centerc=vec3(128.0/255.0);
vec3 endc=vec3(31.0/255.0,33.0/255.0,46.0/255.0);
vec3 getonecolor(vec4 color){
    float y=color.r*0.299+color.g*0.587+color.b*0.114;
    if(y>=0.5){
        y= (y-0.5)*2.0;
//        y=step(0.0,1.0,y);
        return centerc+(startc-centerc)*y;
    }else{
        y*=2.0;
//        y=step(0.0,1.0,y);//smooth
        return endc+(centerc-endc)*y;
    }

}

void main() {
    nowtime=mod(progress,druction)/druction+0.1;
    nowtime*=100.0;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec4 color=getFromColor(texCoord);
    vec3 y=getonecolor(color);
    color.rgb=y;

    float movex=1.0/240.0;
    texCoord.x-=movex;
    vec4 colorr=getFromColor(texCoord);
    y=getonecolor(colorr);
    color.r=y.r;

    texCoord.x+=movex*2.0;
    vec4 colorb=getFromColor(texCoord);
    y=getonecolor(colorb);
    color.b=y.b;

    float sp=1080.0;
    texCoord=fenkuai(texCoord,sp);
    float num=Rand(texCoord)/2.0;
    gl_FragColor.rgb=mix(color.rgb,vec3(num),0.2);


}
