precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=2000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float Rand(float v) {
    return fract(sin(78.233*v) * 43758.5453);
}



void main() {

    nowtime=mod(progress,druction)/druction+0.1;
    nowtime*=100.0;
    vec2 texCoord = textureCoordinate.xy / vec2(1.0).xy;
    vec4 color=getFromColor(texCoord);
    float cha=color.a;
    float ran=0.5+Rand(nowtime)/4.0;
    gl_FragColor.rgb=mix(color.rgb,vec3(0.0),cha*ran);
    gl_FragColor.a=1.0;
}
