precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
const float PI = 3.1415926;
uniform lowp float ratio;
float druction=3000.0;
float nowtime=0.0;

vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

float Rand(vec2 v) {
    return fract(sin(dot(v.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

vec2 fenkuai(vec2 pro,float sp){
    vec2 usey=pro*sp-fract(pro*sp);
    return usey/sp;
}

void main() {
    nowtime=mod(progress,druction)/druction+0.1;
    vec2 texCoord = textureCoordinate / vec2(1.0);
    gl_FragColor.a=1.0;

    float jiange=700.0;
    float yu1=mod(progress,druction);
    float yu=mod(mod(progress,druction),jiange);
//    x平移
    if(yu>jiange/2.0&&(yu1>2100.0||yu1<1400.0)){
        float ran=(Rand(vec2(texCoord.y,nowtime))-0.5)/150.0/ratio;
        float movex=yu-jiange/2.0;
        if(movex>jiange/4.0){
            movex=jiange/2.0-movex;
        }
        movex/=(jiange/4.0*100.0);
        texCoord.x=texCoord.x+ran+movex;
    }
    vec4 color=getFromColor(texCoord);

    texCoord=fenkuai(texCoord,720.0);
//    噪点
    float num=Rand(texCoord*nowtime*10.0)/2.0;
    gl_FragColor.rgb=mix(color.rgb,vec3(num),0.1);
//    gl_FragColor=color;
//    gl_FragColor=vec4(num);

}
