#extension GL_OES_EGL_image_external : require

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform samplerExternalOES inputImageTexture2;
uniform  float progress;
uniform  float ratio;


vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
void main() {
    vec2 texCoord = textureCoordinate.xy/ vec2(1.0);
    vec4 color1 = getFromColor(texCoord);
    vec4 color11 = getToColor(texCoord);
    color1=color1/2.0+color11/2.0;
//    vec4 color1 =vec4(1.0);
    vec4 color2=texture2D(inputImageTexture3, texCoord);


    //    vec3 keying_color = vec3(0.25, 1.0, 0.0);
    //    float thresh = 0.6; // [0, 1.732]
    //    float slope = 0.50; // [0, 1]
    //    vec3 input_color = color2.rgb;
    //    float d = abs(length(abs(keying_color.rgb - input_color.rgb)));
    //    float edge0 = thresh * (1.0 - slope);
    //    float alpha = smoothstep(edge0, thresh, d);
    //    gl_FragColor = mix(color1,color2, alpha);
    //
    //    if(true){
    //        return;
    //    }
    //
    //
    //    float mixnum=0.0;
    ////    if(color2.g-color2.r<0.2||color2.g-color2.r<0.2){
    ////        mixnum=1.0;
    ////    }else{
    //        float rbAverage = (color2.r) * 0.5 + color2.b * 0.5;
    //        float gDelta = color2.g - rbAverage;
    //        mixnum = 1.0 - smoothstep(0.0, 0.25, gDelta);
    //        mixnum = mod(mixnum,3.0);
    ////    }
    //
    //    gl_FragColor = mix(color1,color2, mixnum);

    if (color2.g - color2.r >= 0.1 && color2.g - color2.b >= 0.1) {
        color2 = vec4(color2.r, (color2.r + color2.b) / 2.0, color2.b, 1.0 - color2.g);
    } else {
        color2 = vec4(color2.r, color2.g, color2.b, color2.a);
    }
    gl_FragColor = mix(color1,color2, color2.a);

}

