precision highp float;

attribute vec4 position;
attribute vec4 inputTextureCoordinate;
varying highp vec2 textureCoordinate;
uniform mat4 inputMatrix;

void main()
{
    gl_Position = inputMatrix * position;

    textureCoordinate = inputTextureCoordinate.xy;
    textureCoordinate.y = 1.0 - textureCoordinate.y;
}
