precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec4 color;
uniform vec2 scale;
uniform vec2 scale2;
vec2 center = vec2(0.5);

void main() {
    vec2 colorpos = (textureCoordinate - center) * scale2;
//    if (abs(colorpos.x) <= 1.0) {
//        gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
//    } else
    if (abs(colorpos.x) <= 0.5 && abs(colorpos.y) <= 0.5) {
        colorpos = colorpos * scale;
        if (abs(colorpos.x) <= 0.5 && abs(colorpos.y) <= 0.5) {
            colorpos += center;
            gl_FragColor = texture2D(inputImageTexture, colorpos);
        } else {
            gl_FragColor = color;
        }
    } else {
        gl_FragColor = vec4(0.0);
    }
}
