precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float alpha;
uniform float progress;
uniform vec2 centersize;
highp vec2 center = vec2(0.5);
//uniform float ly;
//float lx, ly;

void main() {
    vec2 pos = textureCoordinate / 1.0;
    float lx = 0.5-centersize.x/2.0;
    float ly = 0.5-centersize.y/2.0;
    float chax = 0.5 - abs(pos.x - 0.5);
    float chay = 0.5 - abs(pos.y - 0.5);
    if (chax < lx || chay < ly) {
        vec2 usepos;
//        折起来
        if (pos.x > 0.5) {
            pos.x = 1.0 - pos.x;
        }
        if (pos.y > 0.5) {
            pos.y = 1.0 - pos.y;
        }
        //        分成三部分，拐角,上边，左边，
        if (pos.y < ly && pos.x < lx) {
            usepos.x = pos.x / lx / 2.0;
            usepos.y = pos.y / ly / 2.0;
        } else if (pos.y < ly) {
            usepos.x = 0.5;
            usepos.y = pos.y / ly / 2.0;
        } else if (pos.x < lx) {
            usepos.y = 0.5;
            usepos.x = pos.x / lx / 2.0;
        }
//        pos=usepos;
//        vec4 color = texture2D(inputImageTexture, pos);
//        gl_FragColor = color;
        gl_FragColor = texture2D(inputImageTexture, usepos);

        return;
    }
    discard;

//    gl_FragColor=texture2D(inputImageTexture, textureCoordinate);


}
