precision mediump float;

uniform int mirrorImage;
attribute vec4 inputPosition;
uniform mat4 inputMatrix;
attribute vec4 inputTextureCoordinate;

varying vec2 textureCoordinate;



void main() {
    vec4 myPosition = inputPosition;
    if (mirrorImage == 1){
        myPosition.x = -inputPosition.x;
    }
    gl_Position  = inputMatrix*myPosition;
    textureCoordinate = inputTextureCoordinate.xy;
}