precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;

//存储12个最终坐标
vec2 points [13];
//结束时的缩小比例，设置到0.8图像到达指定位置，然后开始按照scales 由小到大开始消失
float scales[13];
float yanshi[13];

float random (in vec2 _st) {
    return fract(sin(dot(_st.xy,
    vec2(12.9898,78.233)))*
    43758.5453123);
}



void main() {


        float usepro=smoothstep(0.,1.0,progress)*1.3;//处理位移
        float useproa=usepro; //透明度单独使用
        float useproscale=0.3+usepro*0.7;//缩放比例单独使用
        float alpha = (progress<0.1)?sqrt(progress*10.0):1.0;
    points[0]=vec2(0.1, 0.12);scales[0]=0.2;yanshi[0]=0.0;
    points[1]=vec2(0.38, 0.18);scales[1]=0.1;yanshi[1]=0.15;
    points[2]=vec2(0.75, 0.125);scales[2]=0.2;yanshi[2]=0.1;
    points[3]=vec2(0.28, 0.28);scales[3]=0.08;yanshi[3]=0.2;
    points[4]=vec2(0.7, 0.3);scales[4]=0.12;yanshi[4]=0.08;
    points[5]=vec2(0.2, 0.5);scales[5]=0.15;yanshi[5]=0.03;
    points[6]=vec2(0.9, 0.47);scales[6]=0.14;yanshi[6]=0.04;
    points[7]=vec2(0.1, 0.67);scales[7]=0.1;yanshi[7]=0.0;
    points[8]=vec2(0.7, 0.69);scales[8]=0.11;yanshi[8]=0.2;
    points[9]=vec2(0.19, 0.83);scales[9]=0.2;yanshi[9]=0.19;
    points[10]=vec2(0.38, 0.84);scales[10]=0.12;yanshi[10]=0.12;
    points[11]=vec2(0.62, 0.87);scales[11]=0.18;yanshi[11]=0.16;
    points[12]=vec2(0.8, 0.84);scales[12]=0.2;yanshi[12]=0.13;
    vec2 center=vec2(0.5);

        vec2 usecenter;
        float usescale;
        gl_FragColor=vec4(0.0);
        for(int i=0;i<13;i++){
            usescale=scales[i]*useproscale;
            usecenter=points[i];

            float centerpro=usepro-yanshi[i];
            if(centerpro<0.0){
                continue;
            }
            centerpro=min(1.0,centerpro);
            usecenter=center+(usecenter-center)*centerpro;
            bool needdo=ratio<1.0?
            (abs(usecenter.x-textureCoordinate.x)<=usescale*ratio/2.0&&
            abs(usecenter.y-textureCoordinate.y)<=usescale/2.0)
            :
            (abs(usecenter.x-textureCoordinate.x)<=usescale/2.0&&
            abs(usecenter.y-textureCoordinate.y)<=usescale/ratio/2.0);

            if(needdo){
                vec2 realpos=center+(textureCoordinate-usecenter)/usescale;
                if(ratio<1.0)
                realpos.x=0.5+(realpos.x-0.5)/ratio;
                else realpos.y=0.5+(realpos.y-0.5)*ratio;
                if(
                abs(realpos.x-0.5)>=(0.48-0.02*(1.0-usepro))||
                abs(realpos.y-0.5)>=(0.48-0.02*(1.0-usepro))){
                    continue;
                }

                vec4 color=texture2D(inputImageTexture, realpos);
                    if(useproa>=1.1){
                        alpha=scales[i]-(useproa-1.1);
                        alpha=max(alpha,0.0)/scales[i];
                        alpha=smoothstep(0.,1.0,alpha);
                    }
                gl_FragColor=mix(gl_FragColor,color,color.a)*alpha;
            }
        }


}
