precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp float progress;
uniform lowp float ratio;
uniform lowp float useoff;
const float PI = 3.1415926;
void main() {
    vec2 pos =textureCoordinate;
    float off=useoff;
    if(ratio<1.0){
        off*=ratio;
    }
    pos.y=pos.y+sin(pos.x*PI+progress*2.0*PI)*off;
    if(abs(pos.y-0.5)>0.5){
        gl_FragColor=vec4(0.0);
    }else{
        gl_FragColor = texture2D(inputImageTexture, pos);
    }

}


