precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
uniform float ratio;
uniform float offmax;
uniform float xoff;
const float PI = 3.1415926;

//左右抖动
void main() {
//    gl_FragColor= texture2D(inputImageTexture, textureCoordinate);return;
    vec2 texCoord=textureCoordinate/vec2(1.0);
    texCoord.x=texCoord.x-(1.0-progress);
    vec4 color=vec4(0.0);
    float num=10.0;
    float total=num*2.0+1.0;
    float offx=offmax*(1.0-progress);
    for (float t = 0.0; t < total; t++) {
        vec2 movepos=texCoord;
        movepos.x+=t*offx;
        vec4 use=texture2D(inputImageTexture, movepos);
//        color=max(color,use);
        color += use;
    }
//    gl_FragColor=color;
    gl_FragColor= vec4(color / total);

}
