precision mediump float;
varying vec2 textureCoordinate;
//stroke
uniform sampler2D inputImageTexture;
//text
uniform sampler2D inputImageTexture2;
uniform float scalex;
uniform float scaley;

vec2 center=vec2(0.5);
void main()
{
    vec2 pos2=vec2(0.0);
    pos2.x=center.x+(textureCoordinate.x-center.x)/scalex;
    pos2.y=center.y+(textureCoordinate.y-center.y)/scaley;
    vec4 text = texture2D(inputImageTexture2, pos2);
    if(pos2.x<0.0||pos2.x>1.0){
        text=vec4(0.0,0.0,0.0,1.0);
    }
    if(pos2.y<0.0||pos2.y>1.0){
        text=vec4(0.0,0.0,0.0,1.0);
    }
    vec4 stroke = texture2D(inputImageTexture, textureCoordinate);
    if(text.r>0.5){
        gl_FragColor.rgb=vec3(0.0);
        gl_FragColor.a=1.0;
    }else{
        gl_FragColor=stroke;
    }

}


