precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform int  type;


const float PI = 3.1415926;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}
void main() {
   vec2 usepos;
//    确定是哪一部分
    float comparevalue;
//    这个计算偏移数值
    float usevalue;
    float useprogress=1.0-progress;
    if(type==0){
        comparevalue=textureCoordinate.y;
        usevalue=textureCoordinate.x;
    }else{
        comparevalue=textureCoordinate.x;
        usevalue=textureCoordinate.y;
    }
    if(comparevalue>1.0/3.0&&comparevalue<2.0/3.0){
        usevalue-=useprogress;
    }else{
        usevalue+=useprogress;
    }
    if(abs(0.5-usevalue)>0.5){
        gl_FragColor= getFromColor(textureCoordinate);
    }else{
        if(type==0){
            usepos=vec2(usevalue,comparevalue);
        }else{
            usepos=vec2(comparevalue,usevalue);
        }
        gl_FragColor= getToColor(usepos);
    }
}
