precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;

float getusepeo(){
    return sqrt(progress);
}
vec2 center=vec2(0.5);
float rand (vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}
void main() {
    vec2 tocenter=center-textureCoordinate;
    float usepro=abs(0.5-progress);
    usepro=pow(0.5+usepro,10.0)/2.0;
    tocenter*=(1.0-usepro);

    float strength = 0.4*usepro;
    vec3 color = vec3(0.0);
    float total = 0.0;
    /* randomize the lookup values to hide the fixed number of samples */
    float offset = rand(textureCoordinate);
    float num=10.0;
    for (float t = 0.0; t <= num; t++) {
        float percent = (t + offset) / num;
        float weight = 4.0 * (percent - percent * percent);
        color += texture2D(inputImageTexture,
        center-tocenter - tocenter * percent * strength).rgb * weight;
        total += weight;
    }
    gl_FragColor= vec4(color / total, 1.0);
//    gl_FragColor=texture2D(inputImageTexture, center+texCoord);
}
