
#extension GL_OES_EGL_image_external : require

precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform samplerExternalOES inputImageTexture3;
uniform  float progress;
uniform  float ratio;


vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

void main() {

    vec2 texCoord = textureCoordinate.xy/ vec2(1.0);
    if(ratio>1.0){
        texCoord.y=0.5+(texCoord.y-0.5)/ratio;
    }else{
        texCoord.x=0.5+(texCoord.x-0.5)*ratio;
    }


//    gl_FragColor=progress<0.5?getToColor(texCoord):getFromColor(texCoord);
//    gl_FragColor+=cadd;

//    gl_FragColor=getFromColor(texCoord)*0.5+getToColor(texCoord)*0.5;

    vec4 cadd=texture2D(inputImageTexture3, texCoord);
    gl_FragColor=mix(
    texture2D(inputImageTexture, textureCoordinate),
    texture2D(inputImageTexture2, textureCoordinate),cadd.r);//step(0.5,cadd.r)
}
