precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;

float getusepeo() {
    return sqrt(progress);
}
vec2 center = vec2(0.5);


void main() {
    vec2 texCoord = textureCoordinate - center;
    float beishu = (1.20 - getusepeo() / 5.0);
    texCoord *= beishu;
    vec2 pos = center + texCoord;
    vec4 color;
    if (pos.x <= 0.0 || pos.x >= 1.0 || pos.y <= 0.0 || pos.y >= 1.0) {
        discard;
    } else {
        color = texture2D(inputImageTexture, pos);
    }
    gl_FragColor = color;
}
