precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;

float getusepeo(){
    return sqrt(progress);
}
vec2 center=vec2(0.5);

void main() {
    vec2 texCoord=textureCoordinate-center;
//    texCoord*=(0.5+getusepeo()/2.0);
    texCoord*=(1.50-getusepeo()/2.0);
    vec2 pos = center + texCoord;

    if (pos.x < 0.0 || pos.x >= 1.0 || pos.y < 0.0 || pos.y >= 1.0) {
        gl_FragColor = vec4(0.0);
    } else {
        vec4 color = texture2D(inputImageTexture, pos);
        //        if (color.a != 1.0) {
        //            gl_FragColor = vec4(0.0);
        //            return;
        //        }
        gl_FragColor = color;
    }
}
