precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float progress;
const float PI = 3.1415926;

float getusepeo(){
    return 1.0-sqrt(progress);
}

float getspeedpro(float usepro){
    return ((cos((usepro + 1.) * PI) / 2.0) + 0.5);
}

float getuseprogress(float mi){
    float useprogress= progress >= 0.5 ? 1.0 - progress : progress;
    useprogress = pow(useprogress * 2.0, mi)/2.0;
    useprogress = progress >= 0.5 ? 1.0 - useprogress : useprogress;
//    useprogress =getspeedpro(useprogress) + 0.5;
    return 1.0-useprogress;
}
//type 左到右
float type=1.0;

void main() {
//    float usepro=getusepeo();
    float usepro=getuseprogress(2.0)/2.0;
    if(type==0.0){
        vec2 texCoord=vec2(textureCoordinate.x+usepro,textureCoordinate.y);
        if(texCoord.x>1.0){
            gl_FragColor=vec4(0.0);return;
        }else
        gl_FragColor=texture2D(inputImageTexture, texCoord);
        if(progress<0.1){
            float usepro=pow(progress*10.0,1.2);
            gl_FragColor*=usepro;
        }
        return;
    }else if(type==1.0){
        vec2 texCoord=vec2(textureCoordinate.x-usepro,textureCoordinate.y);
        if(texCoord.x<0.0){
            gl_FragColor=vec4(0.0);return;
        }else
        gl_FragColor=texture2D(inputImageTexture, texCoord);
        if(progress<0.1){
            float usepro=pow(progress*10.0,1.2);
            gl_FragColor*=usepro;
        }
        return;
    }else if(type==2.0){
        vec2 texCoord=vec2(textureCoordinate.x,textureCoordinate.y+usepro);
        if(texCoord.y>1.0){
            gl_FragColor=vec4(0.0);return;
        }else
        gl_FragColor=texture2D(inputImageTexture, texCoord);
        if(progress<0.1){
            float usepro=pow(progress*10.0,1.2);
            gl_FragColor*=usepro;
        }
        return;
    }else if(type==3.0){
        vec2 texCoord=vec2(textureCoordinate.x,textureCoordinate.y-usepro);
        if(texCoord.y<0.0){
            gl_FragColor=vec4(0.0);return;
        }else
        gl_FragColor=texture2D(inputImageTexture, texCoord);
        if(progress<0.1){
            float usepro=pow(progress*10.0,1.2);
            gl_FragColor*=usepro;
        }
        return;
    }


}
