precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform vec2 domove;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
uniform  int type;
//int type=1;
vec4 showcolor=vec4(1.0,0.5,0.47,1.0);
float showwidth;

void main() {
    showwidth=domove[1]*0.15;
    float outlinepos=domove[0]/2.0;
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    float distance2center=type>0?abs(uv.x-0.5):abs(uv.y-0.5);

    if(outlinepos<distance2center){
        gl_FragColor=getFromColor(uv);
        return;
    }
    if(outlinepos-distance2center<showwidth){
        gl_FragColor = showcolor;
        return;
    }
    float off=outlinepos-distance2center-showwidth;
    if(type>0){
        uv.x=uv.x<0.5?off:1.0-off;
    }else{
        uv.y=uv.y<0.5?off:1.0-off;
    }
    gl_FragColor=getToColor(uv);
}
