precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform vec2 domove;

vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
uniform  int type;

//int type=-1;
vec4 showcolor=vec4(1.0,0.5,0.47,1.0);
float showwidth;

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    vec2 check=type>0?uv:uv.yx;
    float uspro=domove[0];
    showwidth=domove[1]*0.15;
    if(progress<0.5){
        if(check.y>0.5){
            gl_FragColor= getFromColor(uv);
            return;
        }
        check.x=1.0-check.x;
    }else{
        if(check.y<0.5){
            gl_FragColor= getToColor(uv);
            return;
        }
    }

    if(uspro<check.x){
        gl_FragColor=getFromColor(uv);
        return;
    }
    if(uspro-check.x<showwidth){
        gl_FragColor = showcolor;
        return;
    }
    float off=uspro-check.x-showwidth;
    if(type>0){
        uv.x=check.y<0.5?off:1.0-off;
    }else{
        uv.y=check.y<0.5?off:1.0-off;
    }
    gl_FragColor=getToColor(uv);
}
