precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform float ratio;
uniform int type;

uniform vec3 domove;
uniform vec3 domove2;


vec4 getToColor(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}

vec4 showcolor=vec4(1.0,0.5,0.47,1.0);
float showwidth;

void main() {
    vec2 uv = textureCoordinate.xy / vec2(1.0);
    vec2 check;
    if(type==1){
        check=uv;
    }else if(type==2){
        check.x=1.0-uv.x;
        check.y=uv.y;
    }else{
        check=uv.yx;
        if(type==4){
            check.x=1.0-check.x;
        }
    }

    float uspro;
    float showwidth;
    if(check.y<1.0/3.0){
        uspro=domove[0];
        showwidth=domove2[0];
    }else if(check.y<2.0/3.0){
        uspro=domove[1];
        showwidth=domove2[1];
    }else{
        uspro=domove[2];
        showwidth=domove2[2];
    }
    if(uspro<=0.0){
        gl_FragColor=getFromColor(uv);
        return;
    }else if(uspro>=1.0){
        gl_FragColor=getToColor(uv);
        return;
    }


    if(uspro<check.x){
        gl_FragColor=getFromColor(uv);
        return;
    }
    if(uspro-check.x<showwidth){
        gl_FragColor = showcolor;
        return;
    }
    float off=uspro-check.x-showwidth;
    if(type<=2){
        uv.x=type==1?1.0-off:off;
    }else{
        uv.y=type==3?1.0-off:off;
    }
    gl_FragColor=getToColor(uv);
}
