/// 熔铸滤镜.fsh

precision highp float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
void main () {
    vec3 col = texture2D(inputImageTexture,textureCoordinate).rgb;
    gl_FragColor.r = col.r*0.5/(col.g+col.b);
    gl_FragColor.g = col.g*0.5/(col.r+col.b);
    gl_FragColor.b = col.b*0.5/(col.r+col.g);
    gl_FragColor.a = 1.0;
}