/// 对调效果.fsh

precision mediump float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
uniform lowp float Time;

float contrast = 0.5;

void main() {
    vec3 col = texture2D(inputImageTexture,textureCoordinate).rgb;
    gl_FragColor.r = col.g*col.b;
    gl_FragColor.g = col.r*col.b;
    gl_FragColor.b = col.r*col.g;
    gl_FragColor.a = 1.0;
}