// 2-11
// https://gl-transitions.com/editor/CircleCrop
precision mediump float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float progress;
uniform lowp float ratio;//真实比例
vec4 bgcolor = vec4(0.0, 0.0, 0.0, 1.0);// = vec4(0.0, 0.0, 0.0, 1.0)

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


void main() {
    vec2 ratio2 = ratio>1.0?vec2(1.0, 1.0 / ratio):vec2(ratio, 1.0);
    float s = pow(0.5+(progress-0.5)*0.8, 3.0);

    float dist = length((vec2(textureCoordinate) - 0.5) * ratio2);
    gl_FragColor= mix(
    getToColor(textureCoordinate),// branching is ok here as we statically depend on progress uniform (branching won't change over pixels)
    getFromColor(textureCoordinate) ,
    step(s, dist)
    );
}
