
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform float progress;

uniform float ratio;

vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}


void main()
{
    vec2 texCoord = textureCoordinate.xy/ vec2(1.0);
    float ratio2=9.0/16.0;
    if(ratio2>ratio){
        texCoord.x=0.5+(texCoord.x-0.5)*ratio/ratio2;
    }else{
        texCoord.y=0.5+(texCoord.y-0.5)/ratio*ratio2;
    }

    mediump vec4 textureColor =
    progress<=0.5?
    texture2D(inputImageTexture, textureCoordinate):
    texture2D(inputImageTexture2, textureCoordinate);
    mediump vec4 textureColor2 = texture2D(inputImageTexture3, texCoord);
    mediump vec4 whiteColor = vec4(1.0);
    lowp vec4 textureColor3 = whiteColor - ((whiteColor - textureColor2) * (whiteColor - textureColor));
    gl_FragColor =textureColor3;
}
