precision mediump float;
uniform sampler2D u_TextureUnit;
varying vec2 v_TextureCoordinates;



//中心，
//y周扩散范围
//计算x轴的比例
 uniform highp float pos;
 uniform highp float a1;
 uniform highp float a2;

 //uniform 这个修饰词不能直接赋值

 void dosomething(float t,float t1,float t2,float cx,float cy){
 //图形长宽不一的情况下实际是个确定长轴短轴的椭圆，
 //若t2>t1即被拉长则(cy-t)即为长轴上的点x
 //若t2<t1即被压缩则(cy-t)即为短轴上的点y
 //x²/a²+y²/b²=1 a为长轴max(t1,t2)，b为短轴min(t1,t2)
     if(cy>(t-t1)&&cy<(t+t1)){
     float movex=0.0;
        if(t1>t2){
         float move1=1.0-((cy-t)*(cy-t))/(t2*t2);
         movex=sqrt(t1*t1*move1);
        }else{
         float move1=1.0-((cy-t)*(cy-t))/(t1*t1);
         movex=sqrt(t2*t2*move1);
        }

     if(cx<=movex){
     gl_FragColor = texture2D(u_TextureUnit,vec2(0.00,cy));
     }else{
     gl_FragColor = texture2D(u_TextureUnit,vec2(cx-movex,cy));
     }
   }

 }

void main()
{
   float cx = v_TextureCoordinates.x;
   float cy = v_TextureCoordinates.y;
   gl_FragColor = texture2D(u_TextureUnit, v_TextureCoordinates);
   dosomething(pos,a1,a2,cx,cy);
}